package discovery

import (
	"encoding/json"
	"strconv"

	"git.loafle.net/overflow/model/meta"
	"git.loafle.net/overflow/model/util"
	"github.com/google/gopacket"
)

type Port struct {
	MetaPortType *meta.MetaPortType `json:"metaPortType,omitempty"`
	PortNumber   json.Number        `json:"portNumber,omitempty"`

	Meta           map[string]map[string]string `json:"meta,omitempty"`
	DiscoveredBy   []string                     `json:"discoveredBy,omitempty"`
	DiscoveredDate *util.Timestamp              `json:"discoveredDate,omitempty"`

	Host        *Host          `json:"host,omitempty"`
	ServiceList []*Service     `json:"serviceList,omitempty"`
	UDPLayer    gopacket.Layer `json:"-"`
}

func NewPort(host *Host, metaPortType *meta.MetaPortType, portNumber int) *Port {
	return &Port{
		Host:         host,
		MetaPortType: metaPortType,
		PortNumber:   json.Number(strconv.Itoa(portNumber)),
	}
}
